﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace ConsoleApplication1
{
    class Program
    {
        static string[] times = { "Palmeiras", "Santos", "Botafogo", "Vasco" };

        static void Main(string[] args)
        {
            //consulta1();
            //consulta2();
            //consulta3();
            //consulta4();
            //consulta5();
            //consulta6();
            //consulta7();
            //consulta8();
            //consulta9();
            //consulta10();
            consulta11();
            //ExemplodeJoin();
            Console.ReadKey();
        }

        public static void consulta1()
        {
           //IEnumerable<string> timesFiltrados = Enumerable.Where( times, n => n.Length >= 6);
            IEnumerable<string> timesFiltrados = times.Where(n => n.Length >= 6);

            foreach (string n in timesFiltrados)
                Console.Write(n + "|");
        }

        public static void consulta2()
        {
            string[] times = { "Palmeiras", "Santos", "Botafogo", "Vasco" };

            IEnumerable<string> consulta = times
                                .Where (n => n.Contains ("s"))
                                .OrderBy (n => n.Length)
                                .Select (n => n.ToUpper( ));

            foreach (string n in consulta)
                Console.Write(n + " | ");
        }
        public static void consulta3()
        {
            string[] times = { "Palmeiras", "Santos", "Botafogo", "Vasco" };

            IEnumerable<int> consulta = times.Select(n => n.Length);

            foreach (int n in consulta)
                Console.Write(n);
        }

        public static void consulta4()
        {
            int[] numeros = { 10, 9, 8, 7, 6 };
            int primeiro = numeros.First();     
            int ultimo = numeros.Last();        
            int segundo = numeros.ElementAt(1);
            int contador = numeros.Count();
            int minimo = numeros.Min();
            int maximo = numeros.Max();
            int soma = numeros.Sum();

            Console.WriteLine(primeiro);//10
            Console.WriteLine(ultimo);//6
            Console.WriteLine(segundo);//9
            //
            Console.WriteLine("Total de elementos : " + contador);
            Console.WriteLine("Elemento mínimo    : " + minimo );
            Console.WriteLine("Elemento mãximo    : " + maximo);
            Console.WriteLine("Soma dos elementos : " + soma);
        }
        public static void consulta5()
        {
            int[] numeros = { 10, 9, 8, 7, 6 };
            bool temONumeroNove = numeros.Contains(9); // true
            bool temMaisqueZeroElementos = numeros.Any(); // true
            bool temUmLementoImpart = numeros.Any(n => n % 2 == 1); // true
            //
            Console.WriteLine("Possui o elemento 9 ? : " + temONumeroNove);
            Console.WriteLine("Possui mais que Zero elementos ? " + temMaisqueZeroElementos);
            Console.WriteLine("Possui um elemento impar ? " + temUmLementoImpart);
        }
        
        public static void consulta6()
        {
            int[] numeros = { 10, 9, 8, 7, 6 , 2, 4};
            
            var primeiros_Tres_Numeros = numeros.Take(3);

            Console.WriteLine("Os 3 primeiros números da sequência são { 10, 9, 8, 7, 6 , 2, 4} :");

            foreach (var n in primeiros_Tres_Numeros) 
            { Console.WriteLine(n); }
        }

        public static void consulta7()
        {
             int[] numeros = { 10, 9, 8, 7, 6 };
            
            var Todos_Numeros_Exceto_Os_3_Primeiros = numeros.Skip(3);

            Console.WriteLine("Listando todos, exceto os 3 primeiros \nnúmeros da sequência são { 10, 9, 8, 7, 6 } :");

            foreach (var n in Todos_Numeros_Exceto_Os_3_Primeiros) 
            { Console.WriteLine(n); }
        }

        public static void consulta8()
        {
              int[] numeros = { 10, 9, 8, 7, 6 };
        }

        public static void consulta9()
        {
            int[] numerosA = { 0, 2, 4, }; 
            int[] numerosB = { 1, 3, 5, }; 
            var todosNumeros = numerosA.Concat(numerosB); 
            Console.WriteLine("Todos os numeros de ambos os arrays:"); 
            foreach (var n in todosNumeros) 
            { Console.WriteLine(n); }
        }

        public static void consulta10()
        {
           
          int[] numerosA = { 0, 2, 3 }; 
          int[] numerosB = { 1, 3, 5 }; 

          var todosNumerosExcetoDuplicados = numerosA.Union(numerosB); 
  
          Console.WriteLine("Todos os numeros de ambos os arrays \nExceto os duplicados:"); 

         foreach (var n in todosNumerosExcetoDuplicados) 
             { Console.WriteLine(n); }
        }

        public static void consulta11()
        {
            int[] numeros = { 1, 2, 3 , 4 ,5,  6 };
            var numerosOrdemReversa = numeros.Reverse() ;

            foreach (var n in numerosOrdemReversa)
              { Console.WriteLine(n); }
        }

 
        public static void ExemplodeJoin()
        {
            var clientes = new List<Cliente>() { 
                new Cliente {Key = 1, Nome = "Macoratti" },
                new Cliente {Key = 2, Nome = "Miriam" },
                new Cliente {Key = 5, Nome = "Janice" } 
            };
 
            var pedidos = new List<Pedido>() {
                new Pedido {Key = 1, NumeroPedido = "Pedido 1" },
                new Pedido {Key = 1, NumeroPedido = "Pedido 2" },
                new Pedido {Key = 4, NumeroPedido = "Pedido 3" },
                new Pedido {Key = 5, NumeroPedido = "Pedido 5" },
            };
 
            var q = from c in clientes
                    join o in pedidos on c.Key equals o.Key
                    select new {c.Nome, o.NumeroPedido};
 
            foreach (var i in q) 
            {
                 Console.WriteLine("Cliente : {0}  Pedido Numero: {1}",i.Nome.PadRight(11, ' '), i.NumeroPedido);
            }
        }
 
        public class Cliente
        {
            public int Key;
            public string Nome;
        }
 
        public class Pedido
        {
            public int Key;
            public string NumeroPedido;
        }
    }
}
